<script context="module">
  export function preload(page) {
    return this.fetch('https://meetus-svelte.firebaseio.com/meetups.json')
      .then( res => {
        if (!res.ok) throw new Error('An error occured, please try again');
        return res.json()
      })
      .then(data => {
        const loadedMeetups = [];
        for (const key in data) {
          loadedMeetups.push({id: key, ...data[key]});
        }
        return {loadedMeetups: loadedMeetups.reverse()};
      })
      .catch(err => {
        this.error(500, 'Could not fetch meetups!');
      });
  }
</script>

<script>
  import { onMount, onDestroy } from 'svelte';
  import { scale } from 'svelte/transition';
  import { flip } from 'svelte/animate';

  // Meetups Store
  import meetups from '../meetups-store';

  // Meetups components
  import MeetupItem from '../components/Meetup/MeetupItem.svelte';
  import MeetupFilter from '../components/Meetup/MeetupFilter.svelte';
  import EditMeetup from '../components/Meetup/EditMeetup.svelte';
  
  // UI components
  import Button from '../components/UI/Button.svelte';
  import Spinner from '../components/UI/Spinner.svelte';
  
  export let loadedMeetups;

  let fetchedMeetups = [];
  let unsubscribe;
  let favsOnly = false;
  let editMode = 'index';
  let editedId;
  let isLoading;

  $: filteredMeetups = favsOnly ? fetchedMeetups.filter(m => m.isFavorite) : fetchedMeetups;

  onMount(() => {
    unsubscribe = meetups.subscribe(items => {
      fetchedMeetups = items;
    });
    meetups.setMeetups(loadedMeetups);
  })

  function setFilter(event) {
    favsOnly = event.detail === 1
  }

  function saveMeetup() {
    editMode = null;
    editedId = null;
  }

  function cancelEdit() {
    editMode = null;
    editedId = null;
  }

  function startEdit(event) {
    editMode = 'edit';
    editedId = event.detail
  }

  onDestroy(() => {
    if (unsubscribe) {
      unsubscribe();
    }
  })
</script>

<style>
  #meetups {
    width: 100%;
    display: grid;
    grid-template-columns: 1fr;
    grid-gap: 1rem;
  }

  #meetup-controls {
    margin: 1rem;
    display: flex;
    justify-content: space-between;
  }

  @media (min-width: 768px) {
    #meetups {
      grid-template-columns: repeat(2, 1fr);
    }

    #no-meetups {
      margin: 1rem;
    }
  }
</style>

<svelte:head>
	<title>All Meetups</title>
</svelte:head>

{#if editMode === 'edit'}
  <EditMeetup id={editedId} on:save={saveMeetup} on:cancel={cancelEdit} />
{/if}
{#if isLoading}
  <Spinner />
{:else}
  <section id="meetup-controls">
    <MeetupFilter on:select={setFilter} />
    <Button on:click={() => editMode = 'edit'}>New Meetup</Button>
  </section>

  {#if filteredMeetups.length === 0}
    <p id="no-meetups">No meetups found, you can start adding some...</p>
  {/if}
  <section id="meetups">
  {#each filteredMeetups as meetup (meetup.id)}
    <div transition:scale animate:flip={{duration: 300}}>
      <MeetupItem
        id={meetup.id}
        title={meetup.title}
        subtitle={meetup.subtitle}
        imageUrl={meetup.imageUrl}
        description={meetup.description}
        address={meetup.address}
        email={meetup.contactEmail}
        isFavorite={meetup.isFavorite}
        on:showdetails
        on:edit={startEdit} />
    </div>
  {/each}
  </section>
{/if}


